CUDNN Frontend API 8.3.0

Public Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
cudnn_frontend::Operation_v8 Class Reference

`#include <cudnn_frontend_Operation.h>`

Inheritance diagram for cudnn_frontend::Operation_v8:
Collaboration diagram for cudnn_frontend::Operation_v8:

## Public Member Functions
std::string | describe () const override
| Return a string describing the backend Descriptor. More...
| Operation_v8 (Operation_v8 &&from)=default
Operation_v8 & | operator= (Operation_v8 &&from)=default
ManagedOpaqueDescriptor | getOutputTensor ()
std::string const & | getTag () const
feature_vector_t | getFeatureVector () const
| ~Operation_v8 ()=default
Public Member Functions inherited from cudnn_frontend::BackendDescriptor
cudnnBackendDescriptor_t | get_raw_desc () const
cudnnStatus_t | get_status () const
| Current status of the descriptor. More...
void | set_status (cudnnStatus_t const status_) const
| Set status of the descriptor. More...
void | set_error (const char *message) const
| Set Diagonistic error message. More...
const char * | get_error () const
| Diagonistic error message if any. More...
ManagedOpaqueDescriptor | get_desc () const
| Returns a copy of underlying managed descriptor. More...
cudnnStatus_t | initialize_managed_backend_pointer (cudnnBackendDescriptorType_t type)
| Initializes the underlying managed descriptor. More...

## Private Member Functions
| Operation_v8 ()=default
| Operation_v8 (Operation_v8 const &)=delete
Operation_v8 & | operator= (Operation_v8 const &)=delete

## Private Attributes
cudnnBackendDescriptorType_t | op_mode = CUDNN_BACKEND_OPERATION_CONVOLUTION_FORWARD_DESCRIPTOR
ManagedOpaqueDescriptor | xdesc = nullptr
ManagedOpaqueDescriptor | ydesc = nullptr
ManagedOpaqueDescriptor | wdesc = nullptr
ManagedOpaqueDescriptor | bdesc = nullptr
ManagedOpaqueDescriptor | dydesc = nullptr
ManagedOpaqueDescriptor | dxdesc = nullptr
ManagedOpaqueDescriptor | dwdesc = nullptr
ManagedOpaqueDescriptor | cdesc = nullptr
ManagedOpaqueDescriptor | amatdesc = nullptr
ManagedOpaqueDescriptor | bmatdesc = nullptr
ManagedOpaqueDescriptor | cmatdesc = nullptr
ManagedOpaqueDescriptor | pwdesc = nullptr
ManagedOpaqueDescriptor | matmuldesc = nullptr
ManagedOpaqueDescriptor | reductiondesc = nullptr
cudnnBackendAttributeType_t | alphabetaType = CUDNN_TYPE_FLOAT
float | alpha_s = 1.0f
float | beta_s = .0f
float | alpha2_s = 1.0f
double | alpha_d = 1.0
double | beta_d = 0.0
double | alpha2_d = 1.0
int64_t | pointwise_port_count = -1
cudnnPointwiseMode_t | pointwise_mode
bool | is_pointwise_activation_fwd_op = false
bool | is_pointwise_activation_bwd_op = false
bool | is_pointwise_math_op = false
std::string | operationTag
feature_vector_t | feature_vector

## Friends
class | OperationBuilder_v8

## Additional Inherited Members
Protected Member Functions inherited from cudnn_frontend::BackendDescriptor
| BackendDescriptor (ManagedOpaqueDescriptor pointer_, cudnnStatus_t status_, std::string err_msg_)
| BackendDescriptor ()=default
Protected Attributes inherited from cudnn_frontend::BackendDescriptor
ManagedOpaqueDescriptor | pointer
cudnnStatus_t | status = CUDNN_STATUS_SUCCESS
| Shared pointer of the OpaqueBackendPointer. More...
std::string | err_msg
| Error message if any being set. More...

## Detailed Description

Operation_v8 Class This class has the properties of the operation Properties:

- xDesc
- yDesc
- wdesc
- bdesc
- dydesc
- dxdesc
- cdesc
- amatdesc
- bmatdesc
- cmatdesc
- pwdesc
- matmuldesc
- reductiondesc
- alpha
- beta
- alpha2

Use OperationBuilder_v8 to build this class. Describe returns a string describing the convolution operation

Definition at line 67 of file cudnn_frontend_Operation.h.

## Constructor & Destructor Documentation

## ◆ Operation_v8() [1/3]

cudnn_frontend::Operation_v8::Operation_v8 | ( | Operation_v8 && | from | ) |
| default

## ◆ ~Operation_v8()

cudnn_frontend::Operation_v8::~Operation_v8 | ( |  | ) |
| default

Referenced by getFeatureVector().

## ◆ Operation_v8() [2/3]

cudnn_frontend::Operation_v8::Operation_v8 | ( |  | ) |
| privatedefault

Referenced by describe(), and getFeatureVector().

## ◆ Operation_v8() [3/3]

cudnn_frontend::Operation_v8::Operation_v8 | ( | Operation_v8 const & |  | ) |
| privatedelete

## Member Function Documentation

## ◆ describe()

std::string cudnn_frontend::Operation_v8::describe | ( |  | ) | const
| inlineoverridevirtual

Return a string describing the backend Descriptor.

Implements cudnn_frontend::BackendDescriptor.

Definition at line 71 of file cudnn_frontend_Operation.h.

References alpha2_d, alpha2_s, alpha_d, alpha_s, alphabetaType, amatdesc, bdesc, beta_d, beta_s, bmatdesc, cdesc, cmatdesc, dwdesc, dxdesc, dydesc, matmuldesc, op_mode, Operation_v8(), operator=(), pwdesc, reductiondesc, nlohmann::to_string(), wdesc, xdesc, and ydesc.

## ◆ getFeatureVector()

feature_vector_t cudnn_frontend::Operation_v8::getFeatureVector | ( |  | ) | const
| inline

Definition at line 111 of file cudnn_frontend_Operation.h.

References feature_vector, Operation_v8(), operator=(), and ~Operation_v8().

## ◆ getOutputTensor()

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::getOutputTensor | ( |  | ) |
| inline

Definition at line 101 of file cudnn_frontend_Operation.h.

References cmatdesc, op_mode, and ydesc.

## ◆ getTag()

std::string const& cudnn_frontend::Operation_v8::getTag | ( |  | ) | const
| inline

Definition at line 106 of file cudnn_frontend_Operation.h.

References operationTag.

## ◆ operator=() [1/2]

Operation_v8& cudnn_frontend::Operation_v8::operator= | ( | Operation_v8 && | from | ) |
| default

Referenced by describe(), and getFeatureVector().

## ◆ operator=() [2/2]

Operation_v8& cudnn_frontend::Operation_v8::operator= | ( | Operation_v8 const & |  | ) |
| privatedelete

## Friends And Related Function Documentation

## ◆ OperationBuilder_v8

friend class OperationBuilder_v8
| friend

Definition at line 69 of file cudnn_frontend_Operation.h.

## Member Data Documentation

## ◆ alpha2_d

double cudnn_frontend::Operation_v8::alpha2_d = 1.0
| private

Definition at line 142 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), describe(), and cudnn_frontend::OperationBuilder_v8::setAlpha2().

## ◆ alpha2_s

float cudnn_frontend::Operation_v8::alpha2_s = 1.0f
| private

Definition at line 141 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), describe(), and cudnn_frontend::OperationBuilder_v8::setAlpha2().

## ◆ alpha_d

double cudnn_frontend::Operation_v8::alpha_d = 1.0
| private

Definition at line 142 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), describe(), and cudnn_frontend::OperationBuilder_v8::setAlpha().

## ◆ alpha_s

float cudnn_frontend::Operation_v8::alpha_s = 1.0f
| private

Definition at line 141 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), describe(), and cudnn_frontend::OperationBuilder_v8::setAlpha().

## ◆ alphabetaType

cudnnBackendAttributeType_t cudnn_frontend::Operation_v8::alphabetaType = CUDNN_TYPE_FLOAT
| private

Definition at line 140 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), describe(), and cudnn_frontend::OperationBuilder_v8::setcDesc().

## ◆ amatdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::amatdesc = nullptr
| private

Definition at line 133 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_matmul_op(), describe(), cudnn_frontend::OperationBuilder_v8::setaMatDesc(), and cudnn_frontend::OperationBuilder_v8::validate_matmul_op().

## ◆ bdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::bdesc = nullptr
| private

Definition at line 128 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), describe(), cudnn_frontend::OperationBuilder_v8::setbDesc(), and cudnn_frontend::OperationBuilder_v8::validate_pointwise_op().

## ◆ beta_d

double cudnn_frontend::Operation_v8::beta_d = 0.0
| private

Definition at line 142 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), describe(), and cudnn_frontend::OperationBuilder_v8::setBeta().

## ◆ beta_s

float cudnn_frontend::Operation_v8::beta_s = .0f
| private

Definition at line 141 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), describe(), and cudnn_frontend::OperationBuilder_v8::setBeta().

## ◆ bmatdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::bmatdesc = nullptr
| private

Definition at line 134 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_matmul_op(), describe(), cudnn_frontend::OperationBuilder_v8::setbMatDesc(), and cudnn_frontend::OperationBuilder_v8::validate_matmul_op().

## ◆ cdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::cdesc = nullptr
| private

Definition at line 132 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), describe(), cudnn_frontend::OperationBuilder_v8::setcDesc(), and cudnn_frontend::OperationBuilder_v8::validate_convolution_op().

## ◆ cmatdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::cmatdesc = nullptr
| private

Definition at line 135 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_matmul_op(), describe(), getOutputTensor(), cudnn_frontend::OperationBuilder_v8::setcMatDesc(), and cudnn_frontend::OperationBuilder_v8::validate_matmul_op().

## ◆ dwdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::dwdesc = nullptr
| private

Definition at line 131 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), describe(), cudnn_frontend::OperationBuilder_v8::setdwDesc(), and cudnn_frontend::OperationBuilder_v8::validate_convolution_op().

## ◆ dxdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::dxdesc = nullptr
| private

Definition at line 130 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), describe(), cudnn_frontend::OperationBuilder_v8::setdxDesc(), cudnn_frontend::OperationBuilder_v8::validate_convolution_op(), and cudnn_frontend::OperationBuilder_v8::validate_pointwise_op().

## ◆ dydesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::dydesc = nullptr
| private

Definition at line 129 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), describe(), cudnn_frontend::OperationBuilder_v8::setdyDesc(), cudnn_frontend::OperationBuilder_v8::validate_convolution_op(), and cudnn_frontend::OperationBuilder_v8::validate_pointwise_op().

## ◆ feature_vector

feature_vector_t cudnn_frontend::Operation_v8::feature_vector
| private

Definition at line 149 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::extract_feature_vector(), and getFeatureVector().

## ◆ is_pointwise_activation_bwd_op

bool cudnn_frontend::Operation_v8::is_pointwise_activation_bwd_op = false
| private

Definition at line 146 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), cudnn_frontend::OperationBuilder_v8::setpwDesc(), and cudnn_frontend::OperationBuilder_v8::validate_pointwise_op().

## ◆ is_pointwise_activation_fwd_op

bool cudnn_frontend::Operation_v8::is_pointwise_activation_fwd_op = false
| private

Definition at line 145 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::setpwDesc(), and cudnn_frontend::OperationBuilder_v8::validate_pointwise_op().

## ◆ is_pointwise_math_op

bool cudnn_frontend::Operation_v8::is_pointwise_math_op = false
| private

Definition at line 147 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::setpwDesc(), and cudnn_frontend::OperationBuilder_v8::validate_pointwise_op().

## ◆ matmuldesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::matmuldesc = nullptr
| private

Definition at line 137 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_matmul_op(), describe(), cudnn_frontend::OperationBuilder_v8::setmatmulDesc(), and cudnn_frontend::OperationBuilder_v8::validate_matmul_op().

## ◆ op_mode

cudnnBackendDescriptorType_t cudnn_frontend::Operation_v8::op_mode = CUDNN_BACKEND_OPERATION_CONVOLUTION_FORWARD_DESCRIPTOR
| private

Definition at line 123 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build(), describe(), getOutputTensor(), cudnn_frontend::OperationBuilder_v8::OperationBuilder_v8(), and cudnn_frontend::OperationBuilder_v8::validate_convolution_op().

## ◆ operationTag

std::string cudnn_frontend::Operation_v8::operationTag
| private

Definition at line 148 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), cudnn_frontend::OperationBuilder_v8::build_matmul_op(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), cudnn_frontend::OperationBuilder_v8::build_reduction_op(), and getTag().

## ◆ pointwise_mode

cudnnPointwiseMode_t cudnn_frontend::Operation_v8::pointwise_mode
| private

Definition at line 144 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), and cudnn_frontend::OperationBuilder_v8::setpwDesc().

## ◆ pointwise_port_count

int64_t cudnn_frontend::Operation_v8::pointwise_port_count = -1
| private

Definition at line 143 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), cudnn_frontend::OperationBuilder_v8::setpwDesc(), and cudnn_frontend::OperationBuilder_v8::validate_pointwise_op().

## ◆ pwdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::pwdesc = nullptr
| private

Definition at line 136 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), describe(), and cudnn_frontend::OperationBuilder_v8::setpwDesc().

## ◆ reductiondesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::reductiondesc = nullptr
| private

Definition at line 138 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_reduction_op(), describe(), cudnn_frontend::OperationBuilder_v8::setreductionDesc(), and cudnn_frontend::OperationBuilder_v8::validate_reduction_op().

## ◆ wdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::wdesc = nullptr
| private

Definition at line 127 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), describe(), cudnn_frontend::OperationBuilder_v8::setwDesc(), and cudnn_frontend::OperationBuilder_v8::validate_convolution_op().

## ◆ xdesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::xdesc = nullptr
| private

Definition at line 125 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), cudnn_frontend::OperationBuilder_v8::build_reduction_op(), describe(), cudnn_frontend::OperationBuilder_v8::setxDesc(), cudnn_frontend::OperationBuilder_v8::validate_convolution_op(), cudnn_frontend::OperationBuilder_v8::validate_pointwise_op(), and cudnn_frontend::OperationBuilder_v8::validate_reduction_op().

## ◆ ydesc

ManagedOpaqueDescriptor cudnn_frontend::Operation_v8::ydesc = nullptr
| private

Definition at line 126 of file cudnn_frontend_Operation.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), cudnn_frontend::OperationBuilder_v8::build_reduction_op(), describe(), getOutputTensor(), cudnn_frontend::OperationBuilder_v8::setyDesc(), cudnn_frontend::OperationBuilder_v8::validate_convolution_op(), cudnn_frontend::OperationBuilder_v8::validate_pointwise_op(), and cudnn_frontend::OperationBuilder_v8::validate_reduction_op().

The documentation for this class was generated from the following file:

- cudnn_frontend_Operation.h